#!/bin/bash
 #### Config ################################

 DBHOST_MST="localhost"
 DBUSER_MST="power_admin"
 DBPASS_MST="BnLshvf88fEggYBKUCCz"
 DB_MST="powerdns"

 DEBUG="no"
 #### End of Config #########################
 REQUIRED_COMMANDS="
 mysql
 "

 # print debug messages to STDERR
 function debug {
         if [ "${DEBUG}" == "yes" ] ; then
                 echo "DEBUG: $@" >&2
         fi
 }

 for CMD in ${REQUIRED_COMMANDS} ; do
         CMDNAME=`echo ${CMD} | awk '{print toupper($1) }' | sed -e s@"-"@""@g`
         export $(eval "echo ${CMDNAME}")=`which ${CMD} 2>/dev/null`
         if [ -z "${!CMDNAME}" ] ; then
                 debug "Command: ${CMD} not found!"
                 exit 1
         else
                 debug "Found command $(echo $CMDNAME) in ${!CMDNAME}"
         fi
 done

#mysql_config_editor set --login-path=update_ttl --host=${DBHOST_MST} --user=${DBUSER_MST} --password
COUNT_UPDATE=''
CUR_IP=''
NEW_IP=''
RED='\033[0;31m' # Red Color
YELLOW='\033[0;33m' # Yellow Color
LIGHTBLUE='\033[1;34m' # LightBlue Color
GREEN='\033[1;32m' # Light Green Color
NC='\033[0m' # No Color

MYSQLCMD_MST="${MYSQL} --login-path=update_ttl --skip-column-names --silent"

ipvalid() {
  # Set up local variables
  local ip=${1:-1.2.3.4}
  local IFS=.; local -a a=($ip)
  # Start with a regex format test
  [[ $ip =~ ^[0-9]+(\.[0-9]+){3}$ ]] || return 1
  # Test values of quads
  for quad in {0..3}; do
    [[ "${a[$quad]}" -gt 255 ]] && return 1
  done
  return 0
}

echo -e "${GREEN}######################################"
echo -e "${GREEN}##  ${YELLOW}Change IP address of A records  ${GREEN}##"
echo -e "######################################${NC}"
echo -e ""

echo -n "Enter current IP address you want to change and press [ENTER]: "
read cur_ip
echo -n "Enter new IP adress (currently: ${cur_ip}) and press [ENTER]: "
read new_ip


if [[ -z "${cur_ip}" ]]
then
echo ""
echo -e "${RED}[ERROR] ${YELLOW}Enter current IP Address!${NC}"
else
if [[ -z "${new_ip}" ]]
then
echo -e "${RED}[ERROR] ${YELLOW}Enter new IP Address!${NC}"
else
if ipvalid "${cur_ip}"; then
  echo "Current IP: ${cur_ip} is valid!"
  
else
  echo "Current IP: ${cur_ip} is invalid!"
  exit 1
fi
if ipvalid "${new_ip}"; then
  echo "New IP: ${new_ip} is valid!"

else
  echo "New IP: ${new_ip} is invalid!"
  exit 1
fi

response=$(echo "use $DB_MST; select * from records where type='A' AND content='${cur_ip}'" | $MYSQLCMD_MST)
        if test ! -z "$response" ; then

while read id domain_id name type content
do
while read notified_serial
do
OLD_SER=${notified_serial}
NEW_SER=$((OLD_SER+1))

done< <(echo "USE ${DB_MST}; SELECT notified_serial FROM domains WHERE id='${domain_id}'" | ${MYSQLCMD_MST})
DATE=$(date +%s)

$(echo "USE ${DB_MST}; UPDATE records SET content = '${new_ip}' WHERE id='${id}'; " | ${MYSQLCMD_MST})
array[${COUNT_UPDATE}]=${domain_id}
#echo -e "${RED}[REC_ID ${NC}#${id}${RED}] ${RED}[DOM_ID ${NC}#${domain_id}${RED}] ${YELLOW}${name} ${NC}${type} ${NC}${content} ${YELLOW}${OLD_SER} ${GREEN}${NEW_SER}${NC}"

COUNT_UPDATE=$((COUNT_UPDATE+1))

done < <(echo "USE ${DB_MST}; SELECT id, domain_id, name, type, content  FROM records WHERE type='A' AND content='${cur_ip}'" | ${MYSQLCMD_MST})
echo -e "${YELLOW}[RESULT] ${GREEN}${COUNT_UPDATE} ${NC}records were updated."

#echo ${array[@]}
uniq=($(printf "%s\n" "${array[@]}" | sort -u)); #echo "${uniq[@]}"

for dom in "${uniq[@]}"; do
#echo ${dom}
while read name
do
notify_pdns=`pdnsutil increase-serial ${name}`
echo "${notify_pdns}"
done< <(echo "USE ${DB_MST}; SELECT name FROM domains WHERE id='${dom}';" | ${MYSQLCMD_MST})


done
 else
echo -e "${RED}[ERROR] ${NC}No results were found"

fi
fi
fi 
