 #!/bin/bash
 #### Config ################################

 DBHOST_MST="localhost"
 DBUSER_MST="power_admin"
 DBPASS_MST="BnLshvf88fEggYBKUCCz"
 DB_MST="powerdns"

 DEBUG="no"
 #### End of Config #########################
 REQUIRED_COMMANDS="
 mysql
 "

 # print debug messages to STDERR
 function debug {
         if [ "${DEBUG}" == "yes" ] ; then
                 echo "DEBUG: $@" >&2
         fi
 }

 for CMD in ${REQUIRED_COMMANDS} ; do
         CMDNAME=`echo ${CMD} | awk '{print toupper($1) }' | sed -e s@"-"@""@g`
         export $(eval "echo ${CMDNAME}")=`which ${CMD} 2>/dev/null`
         if [ -z "${!CMDNAME}" ] ; then
                 debug "Command: ${CMD} not found!"
                 exit 1
         else
                 debug "Found command $(echo $CMDNAME) in ${!CMDNAME}"
         fi
 done

#mysql_config_editor set --login-path=update_ttl --host=${DBHOST_MST} --user=${DBUSER_MST} --password
COUNT_UPDATE='0'
RED='\033[0;31m' # Red Color
YELLOW='\033[0;33m' # Yellow Color
LIGHTBLUE='\033[1;34m' # LightBlue Color
GREEN='\033[1;32m' # Light Green Color
NC='\033[0m' # No Color

MYSQLCMD_MST="${MYSQL} --login-path=update_ttl --skip-column-names --silent"

echo -e "${GREEN}######################################"
echo -e "${GREEN}##  ${YELLOW}Change TTL value 14400 to 3600  ${GREEN}##"
echo -e "######################################${NC}"
echo -e ""
#echo -e "Show Records where TTL is 14400"

response=$(echo "use $DB_MST; select * from records where ttl='14400'" | $MYSQLCMD_MST)
        if test ! -z "$response" ; then

while read id domain_id name type ttl
do
while read notified_serial
do
OLD_SER=${notified_serial}
NEW_SER=$((OLD_SER+1))

done< <(echo "USE ${DB_MST}; SELECT notified_serial FROM domains WHERE id='${domain_id}'" | ${MYSQLCMD_MST})
DATE=$(date +%s)
$(echo "USE ${DB_MST}; UPDATE records SET ttl = '3600' WHERE id='${id}';" | $MYSQLCMD_MST)
#echo -e "${RED}[REC_ID ${NC}#${id}${RED}] ${RED}[DOM_ID ${NC}#${domain_id}${RED}] ${YELLOW}${name} ${NC}${type} ${NC}${ttl} ${YELLOW}${OLD_SER} ${GREEN}${NEW_SER}${NC}"
array[${COUNT_UPDATE}]=${domain_id}
COUNT_UPDATE=$((COUNT_UPDATE+1))
done < <(echo "USE ${DB_MST}; SELECT id, domain_id, name, type, ttl  FROM records WHERE ttl='14400'" | ${MYSQLCMD_MST})

echo -e "${YELLOW}[RESULT] ${GREEN}${COUNT_UPDATE} ${NC}records were updated${NC}"
#echo ${array[@]}
uniq=($(printf "%s\n" "${array[@]}" | sort -u)); #echo "${uniq[@]}"

for dom in "${uniq[@]}"; do
#echo ${dom}
while read name
do
notify_pdns=`pdnsutil increase-serial ${name}`
echo "${notify_pdns}"
done< <(echo "USE ${DB_MST}; SELECT name FROM domains WHERE id='${dom}';" | ${MYSQLCMD_MST})


done
 else
echo -e "${RED}[ERROR] ${NC}No results were found"
fi

